#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
#define int int64_t
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

oset<int> indicies;
vector<vector<int>> h;
void merge(int l, int r) {
    h[l].reserve(h[l].size() + h[r].size());
    for (int i : h[r]) {
        h[l].push_back(i);
    }
    vector<int> pref(h[l].size());
    vector<int> suff(h[l].size());
    int n = h[l].size();
    for (int i = 0; i < n; ++i) {
        if (i != 0) {
            pref[i] = pref[i - 1];
        }
        pref[i] = max(pref[i], h[l][i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        if (i != n - 1) {
            suff[i] = suff[i + 1];
        }
        suff[i] = max(suff[i], h[l][i]);
    }
    int answer = 0;
    for (int i = 0; i < n; ++i) {
        answer += min(pref[i], suff[i]) - h[l][i];
    }
    cout << answer << '\n';
}

void solve() {
    int n;
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        h[i].push_back(t);
    }
    for (int i = 0; i < n; ++i) {
        indicies.insert(i);
    }
    for (int i = 0; i < n - 1; ++i) {
        // for (int i : indicies) {
        //     cout << i << ' ';
        // }
        // cout << endl;
        int k;
        cin >> k;
        auto it = indicies.find_by_order(k - 1);
        // cout << *it << endl;
        // cout << *it + 1 << ' ' << *next(it) + 1 << endl;
        merge(*it, *next(it));
        indicies.erase(next(it));
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}