#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
#define int int64_t
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
 
oset<int> indicies;
vector<deque<int>> h;
void merge(auto lp, auto rp) {
    int l = *lp, r = *rp;
    
    if (h[l].size() > h[r].size()) {
        for (int i : h[r]) {
            h[l].push_back(i);
        }
        h[r].clear();
        indicies.erase(rp);
        vector<int> pref(h[l].size());
        vector<int> suff(h[l].size());
        int n = h[l].size();
        for (int i = 0; i < n; ++i) {
            if (i != 0) {
                pref[i] = pref[i - 1];
            }
            pref[i] = max(pref[i], h[l][i]);
        }
        for (int i = n - 1; i >= 0; --i) {
            if (i != n - 1) {
                suff[i] = suff[i + 1];
            }
            suff[i] = max(suff[i], h[l][i]);
        }
        int answer = 0;
        for (int i = 0; i < n; ++i) {
            answer += min(pref[i], suff[i]) - h[l][i];
        }
        cout << answer << '\n';
    } else {
        for (int i = (int)h[l].size() - 1; i >= 0; --i) {
            h[r].push_front(h[l][i]);
        }
        h[l].clear();
        indicies.erase(lp);
        vector<int> pref(h[r].size());
        vector<int> suff(h[r].size());
        int n = h[r].size();
        for (int i = 0; i < n; ++i) {
            if (i != 0) {
                pref[i] = pref[i - 1];
            }
            pref[i] = max(pref[i], h[r][i]);
        }
        for (int i = n - 1; i >= 0; --i) {
            if (i != n - 1) {
                suff[i] = suff[i + 1];
            }
            suff[i] = max(suff[i], h[r][i]);
        }
        int answer = 0;
        for (int i = 0; i < n; ++i) {
            answer += min(pref[i], suff[i]) - h[r][i];
        }
        cout << answer << '\n';
    }
}

void mergesmallhi(auto &s, auto &data, auto &has, auto lp, auto rp) {
    int l = *lp, r = *rp;
    indicies.erase(rp);
    int mxleft = 0, mxright = 0;
    for (int i = 10; i >= 0; --i) {
        if (has[l][i]) {
            mxleft = i;
            break;
        }
    }
    for (int i = 10; i >= 0; --i) {
        if (has[r][i]) {
            mxright = i;
            break;
        }
    }
    vector<int> newhas(11);
    for (int i = 0; i <= 10; ++i) {
        newhas[i] |= has[l][i];
        newhas[i] |= has[r][i];
    }
    vector<vector<int>> newdata(11, vector<int> (11));
    for (int left = 0; left <= 10; ++left) {
        for (int right = 0; right <= 10; ++right) {
            if (mxleft > min(left, right)) {
                newdata[mxleft][right] += data[r][left][right];
            } else {
                newdata[left][right] += data[r][left][right];
            }
        }
    }
    for (int left = 0; left <= 10; ++left) {
        for (int right = 0; right <= 10; ++right) {
            if (mxright > min(left, right)) {
                newdata[left][mxright] += data[l][left][right];
            } else {
                newdata[left][right] += data[l][left][right];
            }
        }
    }
    int news = s[l] + s[r];
    int answer = -news;
    for (int i = 0; i <= 10; ++i) {
        for (int j = 0; j <= 10; ++j) {
            answer += newdata[i][j] * min(i, j);
        }
    }
    data[l] = newdata;
    s[l] = news;
    has[l] = newhas;
    cout << answer << endl;
}

void solvesmallhi(vector<int> &hs) {
    int n = hs.size();
    vector data(n, vector (11, vector (11, int(0))));
    vector<vector<int>> has(n, vector<int> (11));
    vector<int> s(n);
    for (int i = 0; i < n; ++i) {
        indicies.insert(i);
    }
    for (int i = 0; i < n; ++i) {
        data[i][hs[i]][hs[i]] = 1;
        has[i][hs[i]] = 1;
        s[i] = hs[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        // for (int i : indicies) {
        //     cout << i << ' ';
        // }
        // cout << endl;
        int k;
        cin >> k;
        auto it = indicies.find_by_order(k - 1);
        // cout << *it << endl;
        // cout << *it + 1 << ' ' << *next(it) + 1 << endl;
        mergesmallhi(s, data, has, it, next(it));
    }
}

void solve() {
    int n;
    cin >> n;
    h.resize(n);
    vector<int> hs(n);
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        hs[i] = t;
        mx = max(mx, hs[i]);
        h[i].push_back(t);
    }
    if (mx <= 10) {
        solvesmallhi(hs);
        return;
    }
    for (int i = 0; i < n; ++i) {
        indicies.insert(i);
    }
    for (int i = 0; i < n - 1; ++i) {
        // for (int i : indicies) {
        //     cout << i << ' ';
        // }
        // cout << endl;
        int k;
        cin >> k;
        auto it = indicies.find_by_order(k - 1);
        // cout << *it << endl;
        // cout << *it + 1 << ' ' << *next(it) + 1 << endl;
        merge(it, next(it));
    }
}
 
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}