#include <bits/stdc++.h>
using namespace std;
#define int int64_t

void get(const vector<int> &a, int n, int k, int &answer, int index, int mx, int mn, int left) {
    if (index == n) {
        if (left == 0)
            answer = max(answer, mx - mn);
        return;
    }
    int s = 0;
    for (int i = index; i < n; ++i) {
        int remain = n - i;
        s += a[i];
        get(a, n, k, answer, i + 1, max(mx, s), min(mn, s), left - 1);
        if (remain < left) break;
    }
}

int slow(int n, int k, const vector<int> &a) {
    int answer = 0;
    get(a, n, k, answer, 0, INT_MIN, INT_MAX, k);
    return answer;
}
int fast(int n, int k, const vector<int> &b) {
    vector<int> a(n + 1);
    vector<int> pref(n + 1), suff(n + 2);
    vector<int> prefmin(n + 1);
    prefmin[0] = LLONG_MAX;
    int mn = INT_MAX;
    vector<int> indicies;
    for (int i = 1; i <= n; ++i) {
        a[i] = b[i - 1];
        if (mn > a[i]) {
            mn = a[i];
            indicies = {i};
        } else if (mn == a[i]) {
            indicies.push_back(i);
        }
        pref[i] = pref[i - 1] + a[i];
        prefmin[i] = min(prefmin[i - 1], a[i]);
    }
    vector<int> suffmin(n + 2, INT_MAX);
    for (int i = n ; i >= 1; --i) {
        suffmin[i] = min(suffmin[i + 1], a[i]);
        suff[i] = suff[i + 1] + a[i];
    }
    int len = n - (k - 1);
    int answer = 0;
    for (int i = len; i <= n; ++i) {
        // cout << pref[i] << ' ' << pref[i - len] << ' ' << prefmin[i - len] << ' ' << suffmin[i + 1] << endl;
        answer = max(answer, abs((pref[i] - pref[i - len]) - min(prefmin[i - len], suffmin[i + 1])));
    }
    // cout<< mni << endl;
    // cout << mni - 1 << ' ' << k - 2 << endl;
    
    if (k >= 3) {
        for (int mni : indicies) {
            if (mni - 1 >= k - 2) {
                answer = max(answer, suff[mni + 1] - a[mni]);
            }
            // cout << n - mni << ' ' << k- 2 << endl;
            if (n - mni >= k- 2) {
                answer = max(answer, pref[mni - 1] - a[mni]);
            }
        }
    }
    return answer;
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    cout << fast(n, k, a) << endl;
    return;
    // mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    // #define uid(x, y) uniform_int_distribution<int>(x,y)(rng)
    // while (true) {
    //     int n = uid(2, 5);
    //     int k = uid(2, n);
    //     vector<int> a(n);
    //     for (int i = 0; i < n; ++i) {
    //         a[i] = uid(1, 10);
    //     }
    //     if (slow(n, k, a) != fast(n, k, a)) {
    //         cout << n << ' ' << k << endl;
    //         for (int i : a) cout << i << ' ';
    //         cout << endl;
    //         cout << slow(n, k, a) << ' ' << fast(n, k, a) << endl;
    //         return;
    //     }
    // }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}