#include <bits/stdc++.h>
using namespace std;
#define int int64_t
void fast(int n, int s, const vector<vector<int>> &input) {
    vector<int> start(n), end(n);
    int timer = 0;
    vector<int> cij;
    cij.reserve(100000);
    for (int i = 0; i < n; ++i) {
        int k = input[i].size();
        start[i] = timer;
        for (int j = 0; j < k; ++j) {
            int ci = input[i][j];
            cij.push_back(ci);
            timer++;
        }
        end[i] = timer - 1;
    }
    n = timer;
    vector<vector<bool>> dp(n, vector<bool> (s + 1));
    vector<vector<pair<int, int>>> par(n, vector<pair<int, int>> (s + 1, {-1, -1}));
    int block_id = 0;
    for (int i = start[0]; i <= end[0]; ++i) {
        if (cij[i] <= s) {
            dp[i][cij[i]] = 1;
            par[i][cij[i]] = {0, i};
        }
    }
    for (int i = 0; i < n; ++i) {
        if (end[block_id] < i) block_id++;
        for (int prev = block_id == 0 ? 0 : start[block_id - 1]; prev < i; ++prev) {
            for (int sum = 0; sum <= s; ++sum) {
                if (sum - cij[i] >= 0) {
                    if (dp[prev][sum - cij[i]]) {
                        par[i][sum] = {prev, i};
                    }
                    dp[i][sum] = dp[i][sum] | dp[prev][sum - cij[i]];
                    
                }
            }
        }
    }
    vector<int> indicies_answer;
    for (int i = start.back(); i <= end.back(); ++i) {
        if (dp[i][s]) {
            pair<int, int> now = {i, s};
            while (now.first != -1) {
                if (par[now.first][now.second].second == -1) break;
                indicies_answer.push_back(par[now.first][now.second].second);
                auto [prev, i] = par[now.first][now.second];
                now = {prev, now.second - cij[i]};
            }
            reverse(indicies_answer.begin(), indicies_answer.end());
            cout << "Yes\n";
            vector<vector<int>> blockinds(start.size());
            int block_id_now = 0;
            for (int i : indicies_answer) {
                while (!(start[block_id_now] <= i && i <= end[block_id_now])) block_id_now++;
                blockinds[block_id_now].push_back(i - start[block_id_now] + 1);
            }
            for (auto &i : blockinds) {
                cout << i.size() << '\n';
                for (int j : i) {
                    cout << j << ' ';
                }
                cout << '\n';
            }
            return;
        }
    } 
    cout << "No\n" << endl;
}
void solve() {
// void wa() {
    int n, s;
    cin >> n >> s;
    vector<vector<int>> cij(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        cij[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> cij[i][j];
        }
    }
    fast(n, s, cij);
}
// void solve() {
//     mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//     #define uid(x, y) uniform_int_distribution<int>(x, y)(rng)
//     while (true) {
//         int n = uid(1, 10);
//         int s = uid(1, 100);
//         vector<vector<int>> input(n);
//         for (int i = 0; i < n; ++i) {
//             int k = uid(1, 10);
//             input[i].resize(k);
//             for (int j = 0; j < k; ++j) {
//                 input[i][j] = uid(1, 100);
//             }
//         }
//         fast(n, s, input);
//     }
// }

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}