#include <bits/stdc++.h>
using namespace std;
#define int int64_t
int n, m, k;
vector<vector<int>> grid;
int answer = 0;
void turtlebackwards(set<pair<int, int>> &path, int i, int j, int cnt) {
    pair<int, int> now = {i, j};
    pair<int, int> end = {0, 0};
    if (now == end) {
        if (cnt == k) {
            answer++;
        }
        return;
    }
    if (i < 0 || j < 0) return;
    for (auto [ioff, joff] : array<pair<int, int>, 2>{{{-1, 0}, {0, -1}}}) {
        if (!path.contains({i + ioff, j + joff})) {
            turtlebackwards(path, i + ioff, j + joff, cnt + grid[i][j]);
        }
    }
}

void turtle(vector<pair<int, int>> &path, int i, int j, int cnt) {
    if (i == n - 1 && j == m - 1) {
        set<pair<int, int>> pathset(path.begin(), path.end());
        turtlebackwards(pathset, i, j, cnt + grid[i][j]);
        return;
    }
    if (i > n - 1 || j > m - 1) {
        return;
    }
    for (auto [ioff, joff] : array<pair<int, int>, 2>{{{1, 0}, {0, 1}}}) {
        path.push_back({i + ioff, j + joff});
        turtle(path, i + ioff, j + joff, cnt + grid[i][j]);
        path.pop_back();
    }
}
void solve() {
    cin >> n >> m >> k;
    grid.assign(n, vector<int> (m));
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        grid[x - 1][y - 1] = 1;
    }
    vector<pair<int, int>> path;
    turtle(path, 0, 0, 0);
    cout << answer << endl;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
}