#include <bits/stdc++.h>
using namespace std;
#define int int64_t
int n, m, k;
vector<vector<int>> grid;
int answer = 0;

void backwards(set<pair<int, int>> &path, int i, int j, int cnt) {
    if (i < 0 || j < 0) return;
    if (i == 0 && j == 0) {
        if (cnt == k) {
            answer++;
        }
        return;
    }
    cnt += grid[i][j];
    for (auto [ioff, joff] : array<pair<int, int>, 2>{{{-1, 0}, {0, -1}}}) {
        if (!path.contains({i + ioff, j + joff})) {
            backwards(path, i + ioff, j + joff, cnt);
        }
    }
}

void turtle(vector<pair<int, int>> &path, int i, int j, int cnt) {
    if (i > n - 1 || j > m - 1) return;
    if (i == n - 1 && j == m - 1) {
        if (k - cnt > n + m - 1) return;
        set<pair<int, int>> pathset(path.begin(), path.end());
        pathset.erase({0, 0});
        backwards(pathset, i, j, cnt);
        return;
    }
    cnt += grid[i][j];
    path.push_back({i, j});
    for (auto [ioff, joff] : array<pair<int, int>,2>{{{1, 0}, {0, 1}}}) {
        turtle(path, i + ioff, j + joff, cnt);
    }
    path.pop_back();
}
void solve() {
    cin >> n >> m >> k;
    grid.assign(n, vector<int> (m));
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        grid[x - 1][y - 1] = 1;
    }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < m; ++j) {
    //         cout << grid[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    vector<pair<int,int>> path;
    turtle(path, 0, 0, 0);
    cout << answer << endl;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    solve();
    // for (n = 3; n <= 10; ++n) {
    //     for (m = 3; m <= 10; ++m) {
    //         cout << n << ' ' << m << ' ';
    //         solve();
    //     }
    // }
}